package cn.fantix.phpftp;

import java.io.IOException;
import java.io.InputStream;
import java.io.UnsupportedEncodingException;

/**
 * <i>No description.</i>
 * <hr>
 * <p>This file is created on:
 * 2007-2-22 3:32:48</p>
 *
 * @author fantix
 */
public class PhpInputStream extends InputStream {
    public static final int BUFFER_SIZE = 32 * 1024;

    private PhpFtpService service;

    private String path;

    private byte[] buffer = new byte[BUFFER_SIZE];

    private int cursor = BUFFER_SIZE;

    private long globalCursor = 0;

    private long size = Long.MAX_VALUE;

    public PhpInputStream(PhpFtpService service, String path) {
        this.service = service;
        this.path = path;
    }

    public int read() throws IOException {
        if (cursor >= BUFFER_SIZE)
            doRead();
        globalCursor++;
        return globalCursor > size ? -1 : buffer[cursor++] & 0xff;
    }

    private void doRead() {
        byte[] rtt;
        try {
            rtt = service.read(path, globalCursor, BUFFER_SIZE).getBytes("ISO8859-1");
        } catch (UnsupportedEncodingException e) {
            throw new RuntimeException(e);
        }
        System.arraycopy(rtt, 0, buffer, 0, rtt.length);
        if (rtt.length < BUFFER_SIZE)
            size = globalCursor + rtt.length;
        cursor = 0;
    }
}
